unit TextDlg;

interface

uses Graph, Objects, Dos, VGILow, VGIBase, VGIKeys, VGIDlg, VGIText;

type
     PTextBuffer = ^TTextBuffer;
     TTextBuffer = array [0..65532] of char;
     PTextViewer = ^TTextViewer;
     TTextViewer = object(TControl)
                     BufSize,                       { ࠧ  }
                     TextSize      : word;          { ࠧ ⥪ }
                     BufPtr        : PTextBuffer;   { 뫪   }
                     HScrollBar,                    { ਧ⠫  }
                     VScrollBar    : PScrollBar;    { ⨪ ScrollBar }
                     Limit,                         { ࠧ ⥪ }
                     Size,                          { ࠧ ⥪.  ᨬ.}
                     Delta         : TPoint;        { ⥪饥  }
                     Attr          : byte;          { ⥪.ਡ ⥪ }
                     PozStr        : word;          { 砫 ⥪.ப  .
                                                      न }

                     Constructor Init(X1, Y1, X2, Y2 : integer;
                                      AHScrollBar, AVScrollBar : PScrollBar;
                                      ABufSize : word);
                     {  ꥪ    묨 }

                     Constructor Load(var s : TStream);
                     { 㦠 ꥪ  ⮪ ( ) }

                     Procedure Store (var s : TStream);
                     { ࠭ ꥪ  ⮪ ( ) }

                     Procedure SetData(var rec); virtual;
                     { 㦠   ꥪ }

                     Procedure GetData(var rec); virtual;
                     { 뢠   ꥪ }

                     Function DataSize : word; virtual;
                     { 頥 ࠧ  (ࠧ  + 2) }

                     Procedure Draw; virtual;
                     { ᮢ뢠 ⥪   }

                     Function Handle(code : word) : integer; virtual;
                     { ࠡ稪 ᮡ⨩ }

                     Procedure ScrollTo(X, Y : integer);virtual;
                     { ப稢⥫ ꥪ }

                     Procedure WriteStr(var Buffer : TextBuf; count : word);
                     { 뢠   ⥪ count ᨬ 
                       ப稢  ⠪, ⮡  뫮 .
                        ⮬ #13  #10 ࠡ⠥  ࠭
                       ⥪饩 ப.  뢠,  #10 
                        ।  ᫥饬 饭  楤.
                       ⠥ <BackSpace>  ࠭ ।饣
                       ᨬ. }

                 { private }

                     Procedure CalcLimits;
                     { ⠥ ᨬ쭮 ᫮ ப  ⮫殢  ⥪ }

                     Procedure SetLimit(X,Y:Integer);
                     {  Limit   ࠬ ScrollBar'}
                     Procedure ScrollDraw(X, Y : integer);
                     {     ScrollTo,   頥  ScrollBar' }

                     Function GetString(count : word; var poz : word) : string;
                     { 頥 count ᨬ  , 稭  poz.
                       ஫ ਡ. }

                     Procedure Skip(count : integer; var poz : word);
                     { ய᪠ count ᨬ  , ⠭,
                       ᫨   ப }

                     Procedure NewLine(var poz : word);
                     { ய᪠  ᨬ     ப }

                     Procedure PutString(Y : integer; var poz : word);
                     {    ࠭, 稭  poz, Y -
                       ⨪쭠 न }

                     Function Y2Abs(Y : integer) : word;
                     { 頥 ᮫ न (  )
                       砫 ப   ப ⥪ }

                   end; { TTextViewer }
  PFileViewer = ^TFileViewer;
  TFileViewer = object (TTextViewer)
                  FileName:PString;
                  Constructor Init(X1, Y1, X2, Y2 : integer;
                                      AHScrollBar, AVScrollBar : PScrollBar);

                  Procedure SetData( var Rec ) ; virtual;
                  Procedure GetData( var Rec ) ; virtual;
                  Function DataSize:word;virtual;
                 end;

  Procedure RegisterTextDlg;
  const RTextViewer : TStreamRec = (ObjType:40;
                                    VMTLink:ofs(TypeOf(TTextViewer)^);
                                    Load:@TTextViewer.Load;
                                    Store:@TTextViewer.Store);
        RFileViewer : TStreamRec = (ObjType:41;
                                    VMTLink:ofs(TypeOf(TFileViewer)^);
                                    Load:@TFileViewer.Load;
                                    Store:@TFileViewer.Store);

implementation

  Constructor TTextViewer.Init(X1, Y1, X2, Y2 : integer;
                               AHScrollBar, AVScrollBar : PScrollBar;
                               ABufSize : word);
  begin
    TControl.Init(X1, Y1, X2, Y2);
    BufSize:=ABufSize;
    if BufSize<>0 then GetMem(BufPtr,BufSize);
    Size.X:=(Limits.B.X-Limits.A.X) div 8;
    Size.Y:=(Limits.B.Y-Limits.A.Y) div FontSize;
    HScrollBar:=AHScrollBar;
    if HScrollBar<>nil then HScrollBar^.Link:=@Self;
    VScrollBar:=AVScrollBar;
    if VScrollBar<>nil then VScrollBar^.Link:=@Self;
    Flags:=Flags or vfSelectable;
  end; { Init }

  Constructor TTextViewer.Load(var s : TStream);
  {
    㧪 ꥪ  ⮪
  }
  begin
    TControl.Load(s);
    s.read(BufSize, 2);
    GetMem(BufPtr,BufSize);
    s.read(Size, 4);
    GetControlPtr(s, PControl(HScrollBar));
    GetControlPtr(s, PControl(VScrollBar));
    s.read(TextSize, 2);
    Flags:=Flags or vfSelectable;
  end; { Load }

  Procedure TTextViewer.Store(var s : TStream);
  {
     ꥪ  ⮪
  }
  begin
    TControl.Store(s);
    s.write(BufSize, 2);
    s.write(Size, 4);
    PutControlPtr(s, HScrollBar);
    PutControlPtr(s, VScrollBar);
    s.write(TextSize, 2);
  end; { Store }

  Procedure TTextViewer.CalcLimits;
  {
     ᫮ 祪  ⮫殢  ⥪
  }
    var poz, countChar : word;
        step           : byte;
        ALimit:TPoint;
  begin
    ALimit.X:=0;  ALimit.Y:=0;
    poz:=1;

    while poz<TextSize do
    begin
      countChar:=0;
      if (attr and taDoubleWide)<>0 then step:=2
                                    else step:=1;
      while (poz<TextSize)and (BufPtr^[poz]<>#13)  do
      begin
        if BufPtr^[poz]=^B then
        begin
          inc(poz);
          attr:=ord(BufPtr^[poz]);
          if (ord(BufPtr^[poz]) and taDoubleWide)<>0 then step:=2
                                                     else step:=1;
        end else inc(countChar,step);
        inc(poz);
      end;
      if countChar>ALimit.X then ALimit.X:=countChar;
      inc(ALimit.Y);
      NewLine(poz);
    end;
  { dec(ALimit.Y);}
   inc(ALimit.X);
   SetLimit(ALimit.X,ALimit.Y);
  end; { CalcLimits }

  Procedure TTextViewer.SetData(var rec);
    var r : record
              size : word;
              txt  : TTextBuffer;
            end absolute rec;
  begin
    TextSize:=r.size;
    if TextSize<>0 then
    begin
      system. move(r.txt,BufPtr^,TextSize);
      CalcLimits;
      Delta.X:=32767;
      Delta.Y:=32767;
      ScrollTo(0,0);
    end;
  end; { SetData }

  Procedure TTextViewer.GetData(var rec);
    var r : record
              size : word;
              txt  : TTextBuffer;
            end absolute rec;
  begin
    r.size:=TextSize;
    system.move(BufPtr^,r.txt,TextSize);
  end; { GetData }

  Function TTextViewer.DataSize : word;
  begin
    DataSize:=BufSize+2;
  end; { DataSize }

  Procedure TTextViewer.Draw;
    var i   : integer;
        poz : word;
  begin
    if not Visible then exit;
    poz:=PozStr;
    attr:=0;
    Cursor^.Hide;
    for i:=0 to Pred(Size.Y) do
      PutString(Limits.A.Y+i*FontSize,poz);
    Cursor^.Show;
  end; { Draw }

  Function TTextViewer.Handle(code : word) : integer;
  {
    㭪 ࠡ⪨ ᮡ⨩
  }
  begin
    if (code and $FF00) = kbMousePressed then
    begin
      Owner^.SelectControl(@self);
      Handle:=cmEventProcessed;
    end else
      if Code<>cmScrolling then Handle:=0
      else
        if HScrollBar^.Changed then
        begin
          ScrolltO(HScrollBar^.GetPos,Delta.Y);
          Handle:=cmEventProcessed
        end else
          if VScrollBar^.Changed then
          begin
            ScrollTo(Delta.X,VScrollBar^.GetPos);
            Handle:=cmEventProcessed
          end else Handle:=0;
  end; { Handle }

  Procedure TTextViewer.ScrollTo(X, Y : integer);
  begin
    { । ଠ ScrollBar' }
    HScrollBar^.SetParams(Limit.X-Pred(Size.X),X,1,Size.X);
    VScrollBar^.SetParams(Limit.Y-Pred(Size.Y),Y,1,Size.Y);

    ScrollDraw(X,Y);
  end; { ScrollTo }

  Procedure TTextViewer.WriteStr(var Buffer : TextBuf; count : word);
    var i, j, poz : word;
  begin
    ScrollTo(0,Limit.Y);
    poz:=Y2Abs(Limit.Y);
    NewLine(poz);
    for i:=0 to count do
      if TextSize<=BufSize then
      begin
        case Buffer[i] of
          #13 : begin
                  ScrollTo(0,Delta.Y);
                  poz:=Y2Abs(Delta.Y);
                end;
          #10 : begin
                  ScrollTo(Delta.X,Delta.Y+1);
                  poz:=Y2Abs(Delta.Y);
                end;
          #8  : begin
                  if poz>PozStr then     { ᫨    ᨬ }
                  begin
                    j:=poz;
                    if (j<TextSize) and (BufPtr^[j]<>#13) and
                       (BufPtr^[j]<>#10) then
                    begin
                      while (j<TextSize) and (BufPtr^[j+1]<>#13) do
                      begin
                        BufPtr^[j]:=BufPtr^[j+1];
                        inc(j);
                      end;
                      if (j+1)=TextSize then dec(TextSize)
                                        else BufPtr^[j]:=' ';
                    end;
                  end;
                end;
          else
          begin  {  㪢 }
            BufPtr^[poz]:=Buffer[i];
            inc(poz);
          end;
        end; { case }
      end;
    CalcLimits;
    ScrollTo(0,Limit.Y);
  end;

  Procedure TTextViewer.ScrollDraw(X, Y : integer);
    var sm, ost,i : integer;
        block     : word;
        p         : pointer;
        mov       : Integer;
        poz       : word;
        memblock  : longint;
  begin
  if Visible then
    { ᫥ : ⨪  ਧ⠫? }
    if Delta.X=X then
    begin { ⨪ }
      sm:=Y-Delta.Y;                      { 塞 ᬥ饭 }
      ost:=Size.Y-abs(sm);
      if ost>0 then
      begin {  ࠭ - ⠥ }
        memblock:=MaxAvail;
        if memblock>65521 then memblock:=65521;
        block:=(memblock-6) div (ImageSize(Limits.a.X,1,Limits.b.x,FontSize)-6);
                                                  { ᪮쪮 ப । }
        if block>ost then block:=ost;
        if block>0 then
        begin {  墠 }
          Cursor^.Hide;
          memblock:=ImageSize(Limits.a.x,1,Limits.b.x,block*FontSize);
          GetMem(p,memblock);
          if sm<0 then
        begin
          mov:=Size.Y-block;
          while (ost>0) do
          begin
            if mov<-sm then Mov:=-sm;
            if block>ost then block:=ost;
            GetImage(Limits.A.X,Limits.A.Y+(sm+mov)*FontSize,
                     Limits.B.X,Limits.A.Y+(sm+block+mov)*FontSize-1,p^);
            PutImage(Limits.A.X,(Limits.A.Y+mov*FontSize),p^, NormalPut);
            if block>=ost then ost:=0
                          else dec(ost,block);
            dec(mov,block);
           end
         end
                  else
         begin
          mov:=0;
          while (ost>0) do
          begin
            if block>ost then block:=ost;
            GetImage(Limits.A.X,Limits.A.Y+(sm+mov)*FontSize,
                     Limits.B.X,Limits.A.Y+(sm+block+mov)*FontSize-1,p^);
            PutImage(Limits.A.X,(Limits.A.Y+mov*FontSize),p^, NormalPut);
            if block>=ost then ost:=0
                          else dec(ost,block);
            inc(mov,block);
           end
          end;
          FreeMem(p,memblock);
          PozStr:=Y2Abs(Y);
          attr:=0;
          Delta.Y:=Y;
          Delta.X:=X;
          {  - ᮢ ப,   뫮  ࠭ }
          if sm>0 then
          begin
            poz:=Y2Abs(Y+mov);
            attr:=0;
            for i:=mov to Pred(Size.Y) do
              PutString(Limits.A.Y+i*FontSize,poz)
          end else
          begin
            poz:=PozStr;
            attr:=0;
            for i:=0 to Pred(-sm) do
              PutString(Limits.A.Y+i*FontSize,poz);
          end;
          Cursor^.Show;
          exit;
        end;
      end;
    end;

    if Delta.Y<>Y then PozStr:=Y2Abs(Y);
    Delta.Y:=Y;
    Delta.X:=X;
    Draw;
  end; { ScrollDraw }

  Function TTextViewer.GetString(count : word; var poz : word) : string;
    var i    : word;
        ret  : string;
        step : byte;
  begin
    i:=0;
    if (attr and taDoubleWide)<>0 then step:=2
                                  else step:=1;
    if attr=0 then ret:=''
              else ret:=^B+chr(attr);
    while (i<count) and (poz<TextSize) and (BufPtr^[poz]<>#13)  do
    begin
      if BufPtr^[poz]=^B then
      begin
        ret:=ret+BufPtr^[poz]+BufPtr^[poz+1];
        inc(poz);
        attr:=ord(BufPtr^[poz]);
        if (ord(BufPtr^[poz]) and taDoubleWide)<>0 then step:=2
                                                   else step:=1;
      end else
      begin
        ret:=ret+BufPtr^[poz];
        inc(i,step);
      end;
      inc(poz);
    end;
    GetString:=AdjustString(ret,Size.X);
  end; { GetString }

  Procedure TTextViewer.Skip(count : integer; var poz : word);
    var i    : word;
        step : byte;
  begin
    i:=0;
    if (attr and taDoubleWide)<>0 then step:=2
                                  else step:=1;
    while (i<count) and (poz<TextSize)and (BufPtr^[poz]<>#13)  do
    begin
      if BufPtr^[poz]=^B then
      begin
        inc(poz);
        attr:=ord(BufPtr^[poz]);
        if (ord(BufPtr^[poz]) and taDoubleWide)<>0 then step:=2
                                                   else step:=1;
      end else inc(i,step);
      inc(poz);
    end;
  end; { Skip }

  Procedure TTextViewer.NewLine(var poz : word);
  begin
    skip(255,poz);
    inc(poz,2);
    attr:=0;
  end;

  Procedure TTextViewer.PutString(Y : integer; var poz : word);
  begin
    MoveTo(Limits.a.x,Y);
    Skip(Delta.X,Poz);
    DrawText(GetString(Size.X, poz));
    NewLine(poz);
  end;

  Function TTextViewer.Y2Abs(Y : integer) : word;
    var countChar,
        countStr   : word;
  begin
    countStr:=0;
    countChar:=0;
    while (countStr<Y) and (CountChar<TextSize) do
    begin
      inc(countChar);
      if (BufPtr^[countChar]=#10)and(BufPtr^[Pred(CountChar)]=#13) then
       inc(CountStr);
    end;
    if y<>0 then inc(CountChar);
    Y2abs:=countChar;

  end;
Procedure TTextViewer.SetLimit(X,Y:Integer);
begin
 Limit.X:=X;
 Limit.Y:=Y;
    HScrollBar^.SetParams(Limit.X-Pred(Size.X),Delta.X,1,Size.X);
    VScrollBar^.SetParams(Limit.Y-Pred(Size.Y),Delta.Y,1,Size.Y);
end;
{********************* TFileViewer *****************************}
Constructor TFileViewer.Init(X1, Y1, X2, Y2 : integer;
                                      AHScrollBar, AVScrollBar : PScrollBar);
begin
 TTextViewer.Init(X1,y1,x2,y2,AHScrollBar,AVScrollBar,0);
end;
Function TFileViewer.DataSize:Word;
begin
 DataSize:=SizeOf(PathStr);
end;
Procedure TFileViewer.SetData(var Rec);
var AFileName:PathStr absolute Rec;
    S:TDosStream;
    tmpSize:LongInt;
begin
 if FileName<>nil then DisposeStr(FileName);
 if BufPtr<>nil then freeMem(BufPtr,BufSize);
 BufPtr:=nil;
 FileName:=NewStr(AFileName);
 S.Init(AFileName,stOpenRead);
 if S.Status<>stOk then
  begin
   TextSize:=0;
   BufSize:=0;
   exit;
  end;
 tmpSize:=S.GetSize;
 if tmpSize>65521 then tmpSize:=65521;
 if tmpSize>MaxAvail then tmpSize:=maxAvail;
 BufSize:=tmpSize;
 TextSize:=tmpSize;
 if tmpSize>0 then
  begin
   GetMem(BufPtr,BufSize);
   S.Read(BufPtr^,BufSize);
  end;
 CalcLimits;
 HScrollBar^.SetParams(Limit.X-Pred(Size.X),0,1,Size.X);
 VScrollBar^.SetParams(Limit.Y-Pred(Size.Y),0,1,Size.Y);
 Delta.Y:=-32767;
 ScrollTo(0,0);
end;
Procedure TFileViewer.GetData(var Rec);
var AFileName:PathStr absolute Rec;
begin
 if FileName=nil then AFileName:='' else AFileName:=FileName^;
end;
Procedure RegisterTextDLG;
begin
  RegisterType(RTextViewer);
  RegisterType(RFileViewer);
end;
end.
