{****************************************************************************}
{*                                                                          *}
{*                          Vitus Graphic Interface                         *}
{*                               Version 2.5                               *}
{*           Easy, event driven, object oriented graphic interface          *}
{*                       for Turbo Pascal 5.5 or higher                     *}
{*                 Copyright (c) by Vitus B.Wagner, 1991-1993               *}
{*                                                                          *}
{*                              VGIBASE.PAS                           *}
{*             ᪨ ꥪ, ᪥ Event-Driven ணࠬ     *}
{****************************************************************************}
unit VGIBase;
interface
Uses Graph,Objects,VGILow,VgiKeys;
const
 {⠭ }
  cmCancel = 252;
  cmOk     = 253;
  cmYes    = 254;
  cmNo     = 255;
  cmQuit   = 250;
  cmMenu   = 251;
  cmHelp   = 249;
  cmEventProcessed = -32768;
  cmRedraw = 257;
 { ﭨ  ꥪ}
  vfExecuting =    $0001;{ꥪ  ﭨ 쭮 믮}
  vfVisible   =    $0002;{ꥪ ᮢ  ࠭}
  vfFilterKeys =   $0004;{ꥪ 砥 ᮡ     ணࠬ}
  vfFilterCommands=$0008;{ꥪ 砥    ணࠬ}
  vfOutSideEvents= $0010;{ꥪ 砥 ᮡ  , 騥   ।}
  vfMoveable     = $0020;{ꥪ   }
  vfCentered     = $0040;{ꥪ 業  뢮  ࠭}
  vfSelectable   = $0080;{ꥪ 롨ࠥ  ६饭   Tab}

Type
{********************** ᪨ אַ㣮쭨*****************}
 PGrRect = ^TGrRect;
 TGrRect = object ( TRect )
             Procedure Draw;
             Procedure Fill;
             Function  SaveScreen:PImage;
             Procedure ViewPort(Clip:Boolean);
             Procedure Center(var P:TPoint);
             Procedure Correct;
            end;
{**************  ᪨ ꥪ ****************************}
    PVisibleObject = ^TVisibleObject;
    TVisibleObject = object(TObject)
                       { ꥪ}
                       Limits:TGrRect;
                       {}
                       Flags:Word;
                       Constructor Init(X1,Y1,X2,Y2:Integer);
                       Constructor Load(var S:TStream);
                       Procedure Store(var S:TStream);
                       Procedure Draw;virtual;
                       Procedure Hide;virtual;
                       Function Handle(Code:Word):Integer;virtual;
                     end;
   THelpProc = Procedure (AHelpCtx:Word);
{************************************************************************}
{⢮ 饭 ᮡ⨩ - ᯮ   }
const DisabledCommands:Set of 0..255=[];
    {ࢮ ᮡ⨥ ஥ ⠥ 樮஢ 
     । ᭠砫   ꥪ,  ⮬  MainHandle}
      FirstPositionedEvent:Word=$F000;
     {$IFDEF Ver70}
     HelpProc:THelpProc=nil;
     {$ELSE}
     HelpProcPtr:Pointer=nil;
var  HelpProc:THelpProc absolute HelpProcPtr;
     {$ENDIF}
Function DisabledCommand(cmd:LongInt):Boolean;
{஢, 饭  }
{*******   ப, ᮤঠ騬 ~~뤥 㪢 ********}
{뤠 ப, ᮤঠ ࠢ騥   DrawText, 
ப  ⮬ NormAttr,  뤥 㪢-HiAttr}
Function Tilda2CC(S:STring;NormAttr,HiAttr:Byte):String;
{頥 뤥 㪢}
Function HotChar(S:String):char;
{ 㪢 । -  ( QWERTY/ }
Function GetScanCode(ch:Char):Byte;


implementation
 uses DOS;
 Constructor TVisibleObject.Init(X1,Y1,X2,Y2:Integer);
 begin
  TObject.Init;
  Limits.Assign(X1,Y1,X2,Y2);
 end;
 Constructor TVisibleObject.Load(var S:TStream);
 begin
  TObject.Init;
  S.Read(Limits,SizeOf(Limits));
  S.Read(Flags,SizeOf(Flags));
 end;
 Procedure TVisibleObject.Store(var S:TStream);
 begin
  S.Write(Limits,SizeOf(Limits));
  S.Write(Flags,SizeOf(Flags));
 end;
 Procedure TVisibleObject.Draw;
 begin
  Abstract;
 end;
 Procedure TVisibleObject.Hide;
 begin
  abstract;
 end;
 Function TVisibleObject.Handle(Code:Word):Integer;
 begin
  abstract;
 end;
function Tilda2CC(S:String;NormAttr,HiAttr:Byte):String;
var I:Integer;
begin
  if S[1]<>'~' then begin Insert(^B+Chr($80 or NormAttr),S,1);i:=4 end
  else  i:=1;
  While (i<Length(S))and (S[i]<>'~') do inc(i);
  if i<Length(S) then
   begin
    S[i]:=chr(HiAttr or $80);
    Insert(^B,S,i);
    While (i<=Length(S))and (S[i]<>'~') do inc(i);
    if i<=Length(S) then
     begin
      S[i]:=chr(NormAttr or $80);
      Insert(^B,S,i);
     end
     else if i=Length(S) then Dec(S[0]);
  end;
 Tilda2CC:=S;
end;
Function HotChar(S:String):Char;
var I:Integer;
begin
 i:=1;
 While(i<length(S))and(S[i]<>'~') do inc(i);
 if i<Length(S) then HotChar:=S[Succ(i)]else HotChar:=#0;
end;
const ScanCodes:Array[char] of byte =(
 3,30,48,46,32,18,33,34,35,23,36,37,28,50,49,24,
25,16,19,31,20,22,47,17,45,21,44,26, 0, 0, 0, 0,
57, 2,40, 4, 5, 6, 8,40,10,11, 9,13,51,12,52,53,
11, 2, 3, 4, 5, 6, 7, 8, 9,10,39,39,51,12,52,53,
 3,30,48,46,32,18,33,34,35,23,36,37,38,50,49,24,
25,16,19,31,20,22,47,17,45,21,44,26,43,27, 7,12,
41,30,48,46,32,18,33,34,35,23,36,37,38,50,49,24,
25,16,19,31,20,22,47,17,45,21,44,26,43,27,41, 0,
33,51,32,22,38,20,39,25,48,16,19,37,47,21,36,34,
35,46,49,18,30,26,17,45,23,24,27,31,50,40,52,44,
33,51,32,22,38,20,39,25,48,16,19,37,47,21,36,34,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
35,46,49,18,30,26,17,45,23,24,27,31,50,40,52,44,
41,41, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
Function GetScanCode(ch:Char):Byte;
begin
GetScanCode:=ScanCodes[ch];
end;
{********************** ᪨ אַ㣮쭨*****************}
Procedure TGrRect.Draw;
begin
 if not Empty then Rectangle(A.X,A.Y,Pred(B.X),Pred(B.Y));
end;
Procedure TGrRect.Fill;
begin
 if not Empty then Bar(A.X,A.Y,Pred(B.X),Pred(B.Y));
end;
Function  TGrRect.SaveScreen:PImage;
begin
  if Not Empty then SaveScreen:=ImageToHeap(A.X,A.Y,Pred(B.X),Pred(B.Y))
  else SaveScreen:=nil;
end;
Procedure TGrRect.Correct;
var i:Integer;
begin
 if A.X>B.X then
   begin
    I:=A.X;
    A.X:=B.X;
    B.X:=I;
   end;
 if A.Y>B.Y then
   begin
    I:=A.Y;
    A.Y:=B.Y;
    B.Y:=I;
   end;
end;
Procedure TGrRect.ViewPort(Clip:Boolean);
begin
 if Not Empty then SetViewPort(A.X,A.Y,Pred(B.X),Pred(B.Y),Clip);
end;
Procedure TGrRect.Center(var P:TPoint);
begin
 P.X:=(B.X+LongInt(A.X)) div 2;
 P.Y:=(B.Y+LongInt(A.Y)) div 2
end;
Function DisabledCommand(cmd:LongInt):Boolean;
begin
 DisabledCommand:=( Abs(CMD)<=255) and (Abs(cmd) in DisabledCommands);
end;
end.
