{****************************************************************************}
{*                                                                          *}
{*                          Vitus Graphic Interface                         *}
{*                               Version 2.5                                *}
{*           Easy, event driven, object oriented graphic interface          *}
{*                       for Turbo Pascal 5.5 or higher                     *}
{*                 Copyright (c) by Vitus B.Wagner, 1991-1993               *}
{*                                                                          *}
{*                              VGITEXT.PAS                           *}
{*                   ।⢠ 뢮 ⥪  ࠭                 *}
{****************************************************************************}
{R-}
unit VGIText;
interface
uses Objects,Graph,VGILow;
const
{ਡ ⥪}
taDoubleWide= $40;
taSuperscript= $20;
taSubScript  = $10;
taBold       = $08;
taUnderline  = $04;
taItalic     = $02;
taInverse    = $01;
taNormal     =0;
const
      FontSize:integer = 14;
      IndexFontSize:Integer = 8;

    {  ⥪饣  }

  Procedure DrawText(S:String);
  {
     ப, 稭  ⥪饩 ᪮ 樨
    (  GetX,GetY)    孨 㣫 ᨬ
    ६頥 㪠⥫
      梥⮬ ForeColor  䮭 BackColor
  }

  Procedure DrawTextXY(X,Y:Integer;S:String);
  {
     ப ᮮࠧ  ࠬࠬ SetTextJustify
  }
   Procedure  SetFont8x14(On:Boolean);
  {
    ४砥 䮭 814  88. ᫨ ᫮ ப ࠭ ࠢ 200,  ࠡ⠥.
      ⠫   㬮砭 ⮨  814
  }

  Function ControlCode(Attr:Byte):String;
  {
    頥 塠⮢ ப - ࠢ騩 
  }

  Function CStrLen(S:String):Byte;
  {
    .  ப   . ᨬ
  }

  Function AdjustString(S:String;Width:Byte):String;
  {
   ࠢ ப   ,
   १ 譥   ஡
    뢠  , ᨬ
     ⮬ DoubleWide 䮭
  }

  Procedure LoadFont(Size:Integer;S:PStream);

  Procedure CustomFonts;
  {
    㦠  VGI   
  }

  Procedure SetupFonts(Size,ISize:Integer;FontPtr,IndexPtr:Pointer);
  {
     ⥪騬 ⮬ VGI 짮⥫᪨ 
  }

  Procedure DrawChar(ch : char);
  {
    ᮢ ᨬ ch ⥪騬 ਡ⮬
  }

implementation

const
  AttrFlag : boolean = False;
  Attr : byte = $80;

var
  Data    : array[1..28] of byte;
  SymWidth: byte;

Function ControlCode(Attr:Byte):String;
begin
 ControlCode:=^B+Chr( attr or $80);
end;

type CharMask = array [1..14] of byte;
     Font = array [0..256*14-1] of byte;
     PFont = ^Font;

Procedure Font8x14; external;
{$L FONT8x14.OBJ}
Procedure Font8x8; external;
{$L FONT8x8.OBJ}
Procedure Font8x5;external;
{$L FONT8x5.OBJ}

{$IFNDEF Ver55}
Const F:PFont = @Font8x14;
      Fs:PFont = @Font8x8;
{$ELSE}
var
      F : PFont;
      Fs: PFont;
{$ENDIF}

{ ========================================== }
Procedure GetCharRaster(ch:Char);
begin
  Move(F^[ord(ch)*FontSize],Data,FontSize);
end;

{ ========================================== }

Procedure Bold;
var i : integer;
begin
  for i:=1 to FontSize do
    Data[i]:=Data[i] or Data[i] shr 1;
end;

{ ========================================== }

Procedure Italize;
var i : integer;
begin
  if FontSize<>8 then
  begin
    for i:=1 to 6 do
      Data[i]:=Data[i] shr 2;
    for i:=7 to 8 do
      Data[i]:=Data[i] shr 1;
  end else
    for i:=1 to 4 do
      Data[i]:=Data[i] shr 1;
end;

{ ========================================== }

Procedure Underline;
begin
  Data[FontSize]:=$FF;
end;

{ ========================================== }

Procedure SubScript(ch : char);
begin
  FillChar(Data,FontSize,0);
  Move(Fs^[ord(ch)*IndexFontSize],Data[Succ(FontSize)-IndexFontSize],IndexFontSize);
end;

{ ========================================== }

Procedure SuperScript(ch:Char);
begin
  FillChar(Data,FontSize,0);
  Move(Fs^[ord(ch)*IndexFontSize],Data,IndexFontSize);
end;

{ ========================================== }

Procedure Inverse;
var i:integer;
begin
  For I:=1 to FontSize do
  Data[i]:=not Data[i];
end;

{ ========================================== }

Procedure DoubleWide;
var K:Array[1..14] of byte;
    I:Integer;Mask1,Mask2,W:Word;
begin
  Move(Data,k,FontSize);
  For i:=1 to fontsize do
  begin
    Mask1:=128;
    Mask2:=$C000;
    W:=0;
    While Mask1<>0 do
    begin
      if K[i] and Mask1<>0 then W:=Mask2 or W;
        Mask1:=Mask1 shr 1;
        Mask2:=Mask2 shr 2;
    end;
    Data[2*i-1]:=Hi(W);
    Data[2*i]:=Lo(W);
end;
inc(SymWidth,8);
end;

{ ============================================ }

Procedure DrawChar(ch : char);
  var
    P       : Pimage;

begin
  if AttrFlag then
  begin
    Attr:=ord(ch);
    AttrFlag:=False;
  end else
    if ch=^B then AttrFlag:=True
    else
    begin
      SymWidth:=7; {  PutImage'  8 - 1 }
      GetCharRaster(ch);
      if Attr and taBold <> 0 then Bold;
      if Attr and taSubScript<>0 then Subscript(ch) else
      if Attr and taSuperScript<>0 then superscript(ch);
      if Attr and taItalic<>0 then Italize;
      if Attr and taUnderline<>0 then underline;
      if Attr and taInverse<>0 then inverse;
      if attr and taDoubleWide<>0 then DoubleWide;
      P:=Bits2Image(SymWidth,Pred(FontSize),Data,ForeColor,BackColor);
      PutImage(GetX,GetY,P^,CopyPut);
      DisposeImage(P);
      MoveTo(GetX+Succ(SymWidth),GetY);
    end
end;

{ ============================================ }

Procedure DrawText(s : string);
var     i       : integer;
begin
  AttrFlag:=False;
  Attr:=$80;
   for i:=1 to length(S) do
     DrawChar(s[i]);
end;
{ ============================================ }
Function CStrLen(s : string) : byte;
var now : integer;
   delta: integer;
    len : integer;
begin
  now:=1;
  delta:=1;
  len:=0;

  while (now<=length(s)) do
  begin
    if s[now] = ^B then delta:=-1
    else if delta<0 then
           if (ord(s[now]) and taDoubleWide) = 0 then delta:=1
                                                 else delta:=2
         else inc(len,delta);
    inc(now);
  end;
  CStrLen:=len;
end;
{ ============================================ }
Procedure DrawTextXY(x,y : integer; s : string);
var Settings : TextSettingsType;
    delta_x, delta_y : integer;
    snew : string;
    now  : integer;
begin
  GetTextSettings(Settings);
  if Settings.Font<>DefaultFont then
   begin
     snew:='';
     now:=1;
     while (now<=length(s)) do
     begin
       if s[now]<>^B then snew:=snew+s[now]
                     else inc(now);
       inc(now);
     end;
     s:=snew;
     OutTextXY(X,Y,S);
   end
  else
   begin
  case Settings.Vert of
    TopText    : delta_y:=0;
    CenterText : delta_y:=FontSize div 2;
    BottomText : delta_y:=FontSize;
  end; { case }

  case Settings.Horiz of
    LeftText   : delta_x:=0;
    CenterText : delta_x:=CStrLen(s)*4;
    RightText  : delta_x:=CStrLen(s)*8;
  end; { case }

  x:=x-delta_x;
  y:=y-delta_y;
  {
  if x<0 then x:=0;
  if y<0 then y:=0;
  }

   MoveTo(x,y);
   DrawText(s);
  end;
end;
{ ============================================ }
Function AdjustString(S:String;Width:Byte):String;
begin
 While CStrLen(S)>Width do dec(S[0]);
 S:=S+ControlCode(0);
 While CStrLen(S)<Width do S:=S+' ';
 AdjustString:=S;
end;
{ ============================================ }
Procedure SetFont8x14(On:Boolean);
begin
 if On then
  begin
   FontSize := 14 ;
   IndexFontSize := 8 ;
   F := @Font8x14 ;
   Fs := @Font8x8 ;
  end
 else
  begin
   FontSize := 8 ;
   IndexFontSize := 5 ;
   F :=@Font8x8 ;
   Fs := @Font8x5 ;
  end;
end;

  Procedure LoadFont(Size:Integer;S:PStream);
  begin
   Case Size of
   5:S^.Read(PFont(@Font8x5)^,1280);
   8:S^.Read(PFont(@Font8x8)^,2048);
   14:S^.Read(PFont(@Font8x14)^,3584);
   end;
  end;

  Procedure CustomFonts;
  begin
  end;

  Procedure SetupFonts(Size,ISize:Integer;FontPtr,IndexPtr:Pointer);
  begin
    FontSize:=Size;
    IndexFontSize:=ISize;
    F:=FontPtr;
    Fs:=IndexPtr;
  end;
{$IFDEF Ver55}
begin
  F := @Font8x14;
  Fs:= @Font8x8;
{$ENDIF}
end.
